<?php
namespace FiloBlu\BirthdayCoupon\Observer;

class SetBirthdayCoupon implements \Magento\Framework\Event\ObserverInterface
{
    protected $_customer;
    protected $_birthdayHelper;
    protected $_request;
    protected $_resourceConnection;

    public function __construct(
        \Magento\Customer\Model\Customer $customer,
        \FiloBlu\BirthdayCoupon\Helper\Data $birthdayHelper,
        \Magento\Framework\App\Request\Http $request,
        \Magento\Framework\App\ResourceConnection $resourceConnection
    ) {
        $this->_customer = $customer;
        $this->_birthdayHelper = $birthdayHelper;
        $this->_request = $request;
        $this->_resourceConnection = $resourceConnection;
    }

  public function execute(\Magento\Framework\Event\Observer $observer)
  {
     if($this->_birthdayHelper->isModuleEnabled()) {
         $subscriber = $observer->getSubscriber();
         if($subscriber) {
             $customerId = $subscriber->getData('customer_id');
             if((int)$customerId > 0) {
                 $customer = $this->_customer->load($customerId);
                 $dob = $customer->getDob();
             }
             else {
                 $dob = $this->_request->getParam('dob-newsletter-value');
             }

             if($dob) {
                 $day_of_year = $this->_birthdayHelper->getDayOfYear($dob);
                 $coupon_code = $this->_birthdayHelper->getBirthdayCouponByDay($day_of_year);
                 if($coupon_code && $coupon_code != '') {
                     $connection = $this->_resourceConnection->getConnection();
                     $tableName_subsciber = $this->_resourceConnection->getTableName('newsletter_subscriber');
                     $query_subscriber = "UPDATE ".$tableName_subsciber." SET birthday_coupon = '".$coupon_code."' WHERE subscriber_id = ".$subscriber->getId();
                     $connection->query($query_subscriber);
                 }
             }
         }
     }

     return $observer;
  }
}