<?php
namespace FiloBlu\BirthdayCoupon\Observer;

use Magento\Framework\Exception\CouldNotSaveException;

class ValidateCoupon implements \Magento\Framework\Event\ObserverInterface
{
    protected $_birthdayHelper;
    protected $_checkoutSession;
    protected $_cart;

    public function __construct(
        \FiloBlu\BirthdayCoupon\Helper\Data $birthdayHelper,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Checkout\Model\Cart $cart
    ) {
        $this->_birthdayHelper = $birthdayHelper;
        $this->_checkoutSession = $checkoutSession;
        $this->_cart = $cart;
    }

  public function execute(\Magento\Framework\Event\Observer $observer)
  {
     if($this->_birthdayHelper->getConfig('filoblu_birthdaycoupon_section/options/is_enabled') == 1) {
         $quote = $observer->getQuote();

         if($quote) {
             $coupon_code = $quote->getData('coupon_code');
             if($coupon_code && $coupon_code != '') {
                 if($this->_birthdayHelper->isBirthdayCoupon($coupon_code)) {
                     if($quote->getData('customer_email') != '' || $quote->getData('customer_id') != '') {
                         $validate = $this->_birthdayHelper->validateBirthdayCoupon($quote);
                         if($validate->result == 'false') {
                             $observer->getQuote()->setData('coupon_code', '')->collectTotals();
                         }
                     }
                 }
             }
         }
     }

     return $observer;
  }
}