define([
    'uiComponent',
    'jquery',
    'mage/translate',
    'mage/validation'
], function (Component, $) {
    'use strict';
    var w = window;
    var d = document;
    return Component.extend({
        initialize: function (config, node) {
            var couponCode = $(config['couponCodeSelector']);
            var removeCoupon = $(config['removeCouponSelector']);
            var customerEmail = $("#birthday_customer_email");
            var customerEmailInput = $("#customer_email");

            $(config['applyButton']).on('click', $.proxy(function () {
                couponCode.attr('data-validate', '{required:true}');
                removeCoupon.attr('value', '0');

                var couponVal = couponCode.val();
                if(couponVal != '') {
                    var ajaxUrl = $(node).attr('action').replace("checkout/cart/couponPost/", "filoblu_birthdaycoupon/cart/checkcoupon/");
                    $.post( ajaxUrl, {coupon_code: couponVal}, function( data ) {
                        if(data == 'true') {
                            if(customerEmail.css("display") == 'none') {
                                customerEmail.fadeIn();
                                customerEmailInput.val('');
                            }

                            var errorRequire = 2;
                            if(customerEmailInput.val() != '') {
                                errorRequire = 1;
                            }
                        }
                        else {
                            if(customerEmail.css("display") != 'none') {
                                customerEmailInput.val('');
                                customerEmail.fadeOut();
                                customerEmail.css("display", "none")
                            }
                            var errorRequire = 1;
                        }

                        $(node).attr('action').replace("filoblu_birthdaycoupon/cart/index/", "checkout/cart/couponPost/");
                        if(errorRequire == 1) {
                            $(node).validation().submit();
                        }
                    });
                }
                else {
                    if(customerEmail.css("display") == 'none') {
                        $(node).validation().submit();
                    }
                }
            }, this));

            $(config['cancelButton']).on('click', $.proxy(function () {
                couponCode.removeAttr('data-validate');
                removeCoupon.attr('value', '1');
                $(node).submit();
            }, this));

        }
    });
});